//
//  ViewController.swift
//  textanalyzer-3
//
//  Created by Anil Somayaji on 2/3/22.
//

import UIKit

class ViewController: UIViewController {

    @IBOutlet var t: UITextField!
    @IBOutlet weak var analysisMenuButton: UIButton!
    @IBOutlet weak var analysisResult: UILabel!
    @IBOutlet weak var appTitle: UILabel!
    
    var analysisMode = "None"

//    override func viewDidLoad() {
//        super.viewDidLoad()
//    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        
        setupAnalysisMenu()
        updateAnalysis()
    }

    func setupAnalysisMenu() {
        var menuItems: [UIAction] = []
        
        for mode in analysis.keys {
            let item = UIAction(title: mode) {
                (action) in
                self.analysisMode = mode
                self.updateAnalysis()
            }
            menuItems.append(item)
        }
        
        let analysisMenu = UIMenu(title: "", children: menuItems)
        
        analysisMenuButton.showsMenuAsPrimaryAction = true
        analysisMenuButton.menu = analysisMenu
    }

    func updateAnalysis() {
        if let inputText = t.text {
            if let analysisFunc = analysis[analysisMode] {
                let r = analysisFunc(inputText)
                analysisResult.text = analysisMode + ": " + r
            } else {
                analysisResult.text = "Please choose an analysis mode."
            }
        }
    }
    
    @IBAction func doAnalysis(_ sender: Any) {
        updateAnalysis()
    }
}


func countUpper(s: String) -> String {
    var count = 0
    let upperCase: Set<Character> =
    ["A","B","C","D","E","F","G","H","I","J","K","L","M",
     "N","O","P","Q","R","S","T","U","V","W","X","Y","Z"]
    
    for c in s {
        if (upperCase.contains(c)) {
            count += 1
        }
    }
    
    return String(count)
}

let analysis: [String: (String) -> String] = [
    "Count": countCharacters,
    "Upper Case": countUpper
]

func countCharacters(s: String) -> String {
    let charcount = s.count
    return String(charcount)
}
